//
// i n t e r c e p t . c
//
// Intercept interruption and quit
//
// Dec. 7, 2002 by W.Nishida (http://www.skyfree.org)
//

#include <stdio.h>	// printf()
#include <stdlib.h>	// exit()
#include <unistd.h>	// alarm(), getpid()
#include <signal.h>	// signal(), raise(), SIG*

int num_int = 0, num_quit = 0;

void sig_interrupt(int sig) {
  printf("=== SIGINT was called! ===\n");
  num_int++;
  if (num_int == 4) {
    printf("See you again!\n");
    raise(SIGALRM);
   }
 }

void sig_quit(int sig) {
  printf("=== SIGQUIT was called! ===\n");
  num_quit++;
 }

void sig_alarm(int sig) {
  printf("Time is over!\n");
  printf("Total interruption = %d / quit = %d\n", num_int, num_quit);
  exit(0);
 }

int main() {
  signal(SIGINT,  sig_interrupt);
  signal(SIGQUIT, sig_quit);
  signal(SIGALRM, sig_alarm);

  printf("My PID is %d\n", getpid());
  alarm(15);		// Wait for 15 seconds
  printf("I'm sleeping...\n");
  while(1);		// Loop forever
 }
