//
// s i g n a l . c
//
// A short signal testing program
//
// Nov. 30, 2002 by W.Nishida (http://www.skyfree.org)
//

#include <stdio.h>	// printf()
#include <stdlib.h>	// exit()
#include <unistd.h>	// alarm()
#include <signal.h>	// signal(), SIG*

void sig_interrupt(int sig) {
  printf("=== SIGINT was called! ===\n");
  exit(sig);
 }

void sig_quit(int sig) {
  printf("=== SIGQUIT was called! ===\n");
  exit(sig);
 }

void sig_alarm(int sig) {
  printf("=== SIGALRM was called! ===\n");
  exit(sig);
 }

int main() {
  signal(SIGINT,  sig_interrupt);
  signal(SIGQUIT, sig_quit);
  signal(SIGALRM, sig_alarm);

  alarm(10);		// Wait for 10 seconds
  printf("I'm sleeping...\n");
  while(1);		// Loop forever
 }
