//
// t e r m i o . c
//
// Non-canonical keyboard input
//
// Dec. 8, 2002 by W.Nishida (http://www.skyfree.org)
//

#include <stdio.h>	// printf()
#include <unistd.h>	// read()
#include <termios.h>	// termios{}, tcgetattr(), tcsetattr()
#include <unistd.h>	// STDIN_FILENO

int main(int argc, char** argv) {
  int ret;
  struct termios tm, tmo;	// "termios" structure holders
  unsigned char key;

  // Read current "termios" parameter

  ret  = tcgetattr(STDIN_FILENO, &tm);
  ret |= tcgetattr(STDIN_FILENO, &tmo);
  if (ret < 0) {
    printf("tcgetattr() failure!\n");
    return 1;
   }

  // Disable canonical mode, echo output, signal, 
  // stripping, line terminator translation, xon/xoff

  tm.c_lflag &= ~(ECHO | ICANON | ISIG);
  tm.c_iflag &= ~(ISTRIP | INLCR | ICRNL | IGNCR | IXON | IXOFF);
  ret = tcsetattr(STDIN_FILENO, TCSANOW, &tm);
  if (ret < 0) {
    printf("tcsetattr() failure!\n");
    return 1;
   }

  // Read key data

  printf("Hit any key please (Press ESC key to abort).\n");
  while (1) {
    ret = read(STDIN_FILENO, &key, 1);	// Read a data
    printf("%02X\n", key);		// Display it
    if (key == '\033')			// ESC key?
      break;
   }

  // Restore the original "termios"

  ret = tcsetattr(STDIN_FILENO, TCSANOW, &tmo);
  if (ret < 0) {
    printf("tcsetattr() failure!\n");
    ret = 1;
   }
  return 0;
 }
